﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EFramework.Core.Contracts;

namespace EFramework.Core.Events
{
    internal class EventsRepository
    {
        private readonly HashSet<Delegate> handlers;


        public EventsRepository()
        {
            this.handlers = new HashSet<Delegate>();
        }


        public void Add(Delegate handler)
        {
            Ensure.IsNotNull(() => handler);

            this.handlers.Add(handler);
        }

        public void Remove(Delegate handler)
        {
            Ensure.IsNotNull(() => handler);

            this.handlers.Remove(handler);
        }

        public IEnumerable<Delegate> Enumerate()
        {
            return this.handlers;
        }
    }
}
