﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using EFramework.Core.Contracts;

namespace EFramework.Core.Helpers
{
    public static class NumberHelper
    {
        private static readonly Regex NumberDecRegex = new Regex(@"^[0-9]+$");
        public static bool IsNumberDec(string value)
        {
            Ensure.IsNotNull(() => value);

            return NumberHelper.NumberDecRegex.IsMatch(value);
        }

        private static readonly Regex NumberHexRegex = new Regex(@"^(0x)?[0-9a-f]+$", RegexOptions.IgnoreCase);
        public static bool IsNumberHex(string value)
        {
            Ensure.IsNotNull(() => value);

            return NumberHelper.NumberHexRegex.IsMatch(value);
        }
    }
}
