﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NUnit.Framework;

namespace EFramework.Model.Tests
{
    [TestFixture]
    public class EntityExtensionsFixture
    {
        [Test]
        public void CanCreateRawIdentifiersFromListOfEntities()
        {
            var id1 = Guid.NewGuid();
            var instance1 = new EntityA(id1);
            var id2 = Guid.NewGuid();
            var instance2 = new EntityA(id2);

            var identifiers = EntityExtensions.ToIds(new[] { instance1, instance2 });
            CollectionAssert.AreEquivalent(new[] { id1, id2 }, identifiers, "Both list of identifiers should be equivalent.");
        }

        [Test, ExpectedException(typeof(ArgumentException))]
        public void CanGuardListOfEntitiesParameter()
        {
            EntityExtensions.ToIds<Entity>(null);
        }


        internal class EntityA : Entity
        {
            public EntityA(Guid id)
                : base(Identifier.From<EntityA>(id))
            {
            }
        }
    }
}
