﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace EFramework.Model
{
    public abstract class Package : ContainerBase
    {
        private readonly Identifier leader;


        public Package(Identifier leader)
        {
            this.leader = leader;
        }


        public TEntity Leader<TEntity>()
            where TEntity : Entity
        {
            if (this.leader == null)
            {
                return this.GetAll<TEntity>().First();
            }
            else
            {
                return this.Get<TEntity>(this.leader);
            }
        }
    }

    public class Package<TEntity> : Package
        where TEntity : Entity
    {
        public Package(Identifier leader = null)
            : base(leader)
        {
        }


        public TEntity Leader()
        {
            return this.Leader<TEntity>();
        }


        public void Add(params Entity[] entities)
        {
            this.Add(entities.AsEnumerable());
        }

        public void Add(IEnumerable<Entity> entities)
        {
            foreach (var entity in entities)
            {
                this.Entries.Add(entity.Identifier, entity);
            }
        }
    }
}
