﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace EFramework.Model
{
    public static class PackageExtensions
    {
        public static Package<TTo> SwitchTo<TFrom, TTo>(this Package<TFrom> target, Identifier leader = null)
            where TFrom : Entity
            where TTo : Entity
        {
            var result = new Package<TTo>(leader);

            result.Add(target.GetAll());

            return result;
        }

        public static Container ToContainer(this Package target)
        {
            var result = new Container(Guid.NewGuid());

            result.Add(target.GetAll());

            return result;
        }
    }
}
