﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace EFramework.Model.Splitting
{
    public static class SplitExtensions
    {
        public static IEnumerable<Package<TEntity>> Split<TEntity>(this Container container, SplitSettings settings)
            where TEntity : Entity
        {
            foreach (var entity in container.GetAll<TEntity>())
            {
                var package = new Package<TEntity>();
                var entityTyAdd = entity;

                if (settings.CloneEntities)
                {
                    entityTyAdd = (TEntity)entityTyAdd.Clone();
                }

                package.Add(entityTyAdd);

                foreach (var reference in entityTyAdd.GetAll())
                {
                    var childEntity = container.Get(reference);

                    if (settings.CloneEntities)
                    {
                        childEntity = childEntity.Clone();
                    }

                    package.Add(childEntity);
                }

                yield return package;
            }
        }
    }
}
