﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Xml.Linq;

namespace EFramework.Networking.Parser
{
    [DebuggerDisplay("{name}: {value}")]
    public sealed class HAttribute
    {
        private readonly string name;
        private readonly string value;

        internal HAttribute(string name, string value)
        {
            this.name = name;
            this.value = value;

            this.name = this.name.Replace("\"", "").Replace(",", "").Replace("'", "");
        }

        public string Name
        {
            get { return this.name; }
        }

        public string Value
        {
            get { return this.value; }
        }

        public XAttribute ToXml()
        {
            return new XAttribute(this.name, this.value);
        }
    }
}
