﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;

namespace EFramework.Networking.Parser
{
    [DebuggerDisplay("Count: {items.Count}")]
    public sealed class HAttributeCollection : IEnumerable<HAttribute>
    {
        #region Private Fields
        private readonly List<HAttribute> items;
        #endregion
        #region Constructors
        internal HAttributeCollection()
        {
            this.items = new List<HAttribute>();
        }
        #endregion

        #region Public Members
        public int Count
        {
            get { return this.items.Count; }
        }

        public string this[string name]
        {
            get { return this.items.Where(x => x.Name == name).Select(x => x.Value).FirstOrDefault() ?? String.Empty; }
        }
        #endregion
        #region Internal Members
        internal void Add(HAttribute element)
        {
            this.items.Add(element);
        }
        #endregion

        #region IEnumerable Members
        IEnumerator<HAttribute> IEnumerable<HAttribute>.GetEnumerator()
        {
            return this.items.GetEnumerator();
        }

        IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return this.items.GetEnumerator();
        }
        #endregion
    }
}
