﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Xml.Linq;

namespace EFramework.Networking.Parser
{
    [DebuggerDisplay("Comment: {text}")]
    public sealed class HComment : HElement
    {
        private readonly string text;
        private readonly HContainer owner;

        internal HComment(HContainer owner, string text)
        {
            this.owner = owner;
            this.text = text;
        }

        public override HContainer Owner
        {
            get { return this.owner; }
        }

        public string Text
        {
            get { return this.text; }
        }

        public override XNode ToXml()
        {
            return new XComment(this.text);
        }
    }
}
