﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;

namespace EFramework.Networking.Parser
{
    [DebuggerDisplay("Count: {items.Count}")]
    public sealed class HElementCollection : IEnumerable<HElement>
    {
        private readonly List<HElement> items;

        internal HElementCollection()
        {
            this.items = new List<HElement>();
        }

        public int Count
        {
            get { return this.items.Count; }
        }

        public IEnumerable<T> OfType<T>() where T : HElement
        {
            return this.items.OfType<T>();
        }

        internal HElement Add(HElement element)
        {
            this.items.Add(element);
            return element;
        }

        IEnumerator<HElement> IEnumerable<HElement>.GetEnumerator()
        {
            return this.items.GetEnumerator();
        }

        IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return this.items.GetEnumerator();
        }
    }
}
