﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace EFramework.Networking.Parser
{
    public static class HExtensions
    {
        public static IEnumerable<TElement> Descendants<TElement>(this HContainer container)
            where TElement : HElement
        {
            foreach (var element in container.Children.OfType<HElement>())
            {
                if (element is TElement)
                    yield return element as TElement;

                if (element is HContainer)
                    foreach (var child in (element as HContainer).Descendants<TElement>())
                        yield return child;
            }
        }
    }
}
