﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Xml.Linq;

namespace EFramework.Networking.Parser
{
    [DebuggerDisplay("Text: {value}")]
    public sealed class HText : HElement
    {
        private readonly string value;
        private readonly HContainer owner;

        internal HText(HContainer owner, string value)
        {
            this.value = value;
            this.owner = owner;
        }

        public override HContainer Owner
        {
            get { return this.owner; }
        }

        public string Value
        {
            get { return this.value; }
        }

        public override XNode ToXml()
        {
            return new XCData(this.value);
        }
    }
}
