﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Media;

namespace MDownloader.Core.Client.Behaviours
{
    public static class ImageBehaviours
    {
        public static readonly DependencyProperty ImageSourceProperty =
            DependencyProperty.RegisterAttached(
                "ImageSource",
                typeof(ImageSource),
                typeof(ImageBehaviours),
                new PropertyMetadata(default(ImageSource)));

        public static ImageSource GetImageSource(DependencyObject target)
        {
            return (ImageSource)target.GetValue(ImageBehaviours.ImageSourceProperty);
        }

        public static void SetImageSource(DependencyObject target, ImageSource value)
        {
            target.SetValue(ImageBehaviours.ImageSourceProperty, value);
        }
    }
}
