﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Interactivity;

namespace MDownloader.Core.Client.Behaviours.Triggers
{
    public class RoutedEventTrigger : EventTriggerBase<DependencyObject>
    {
        public RoutedEvent target;


        public RoutedEvent Target
        {
            get { return this.target; }
            set { this.target = value; }
        }


        protected override void OnAttached()
        {
            var behaviour = this.AssociatedObject as Behavior;
            var associatedElement = this.AssociatedObject as FrameworkElement;

            if (behaviour != null)
            {
                associatedElement = ((IAttachedObject)behaviour).AssociatedObject as FrameworkElement;
            }

            if (this.target != null && associatedElement != null)
            {
                associatedElement.AddHandler(this.target, new RoutedEventHandler(this.OnRoutedEvent));
            }
        }

        private void OnRoutedEvent(object sender, RoutedEventArgs args)
        {
            this.OnEvent(args);
        }

        protected override string GetEventName()
        {
            if (this.target == null)
            {
                return String.Empty;
            }

            return this.target.Name;
        }
    }
}
