﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Windows.Threading;

namespace MDownloader.Client.Controllers
{
    public abstract class ControllerBase
    {
        private readonly ExecutionNotifier executionNotifier = new ExecutionNotifier();
        private readonly Guid id = Guid.NewGuid();


        public Guid Id
        {
            get { return this.id; }
        }

        public ExecutionNotifier Executor
        {
            get { return this.executionNotifier; }
        }


        protected void Execute(Action action, Action onComplete = null)
        {
            var dispatcher = Dispatcher.CurrentDispatcher;

            ThreadPool.QueueUserWorkItem(new WaitCallback(state =>
            {
                this.executionNotifier.IsBusy = true;

                try
                {
                    action();
                }
                catch
                {
                }
                finally
                {
                    this.executionNotifier.IsBusy = false;
                }

                if (onComplete != null)
                {
                    dispatcher.BeginInvoke(onComplete);
                }
            }));
        }
    }
}
