﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace MDownloader.Client.Notifications
{
    [AttributeUsage(AttributeTargets.Class, AllowMultiple = true)]
    public sealed class ConnectorAttribute : Attribute
    {
        private readonly Type connectorType;
        private readonly string connectorName;


        public ConnectorAttribute(Type connectorType, string connectorName)
        {
            this.connectorType = connectorType;
            this.connectorName = connectorName;
        }


        public Type ConnectorType
        {
            get { return this.connectorType; }
        }

        public string ConnectorName
        {
            get { return this.connectorName; }
        }
    }
}
