﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;

namespace MDownloader.Client.Notifications
{
    internal static class ConnectorFactory
    {
        public static object Find(IServiceProvider serviceProvider, Type connectorType, string connectorName)
        {
            var query = from assembly in AppDomain.CurrentDomain.GetAssemblies()
                        from type in assembly.GetTypes()
                        from connectorAttribute in type.GetCustomAttributes(typeof(ConnectorAttribute), false).OfType<ConnectorAttribute>()
                        where connectorAttribute.ConnectorName == connectorName
                        where connectorAttribute.ConnectorType == connectorType
                        select type;

            return serviceProvider.GetService(query.First());
        }
    }
}
