﻿using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Text;

namespace MDownloader.Client.Operations.Implementation
{
    [Export(typeof(IOperationFactory))]
    internal class OperationFactory : IOperationFactory
    {
        [ImportMany]
        private Lazy<IOperationProvider, IOperationProviderMetadata>[] providers;


        public IEnumerable<IOperationInstance> Collect(ICollection<IOperationTarget> context)
        {
            var query = from item in context
                        group item by item.Type into targets
                        join entry in this.providers on targets.Key equals entry.Metadata.Target
                        from operation in entry.Value.Provide()
                        select new OperationInstance
                        {
                            Operation = operation,
                            Targets = targets.ToArray(),
                        };

            return query.ToArray();
        }
    }
}
