﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Input;

namespace MDownloader.Client.Operations
{
    public class OperationViewModel
    {
        private readonly ICommand command;
        private readonly IOperationInstance instance;
        private readonly object context;


        internal OperationViewModel(IOperationInstance instance, object context)
        {
            this.instance = instance;
            this.command = new DelegateCommand(this.OnExecute, this.OnCanExecute);
            this.context = context;
        }


        public string Name
        {
            get { return this.instance.Operation.Name; }
        }

        public ICommand Command
        {
            get { return this.command; }
        }


        private bool OnCanExecute()
        {
            return this.instance.Operation.CanExecute(this.context, this.instance.Targets);
        }

        private void OnExecute()
        {
            this.instance.Operation.Execute(this.context, this.instance.Targets);
        }


        public override string ToString()
        {
            return this.Name;
        }
    }
}
