﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace MDownloader.Core.Server.Exceptions
{
    public sealed class UnexpectedDataException : ApplicationException
    {
        private Type response;
        private Dictionary<string, byte[]> data;


        public UnexpectedDataException(Type response, IDictionary<string, byte[]> data)
            : base("Response contains unexpected data.")
        {
            this.response = response;
            this.data = data.ToDictionary(x => x.Key, x => x.Value);
        }


        public Type Response
        {
            get { return this.response; }
        }

        public IDictionary<string, byte[]> Data
        {
            get { return this.data; }
        }
    }
}
