﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace MDownloader.Core
{
    public class EntityEventArgs<TTarget> : EventArgs
        where TTarget : class
    {
        private readonly TTarget[] targets;
        private readonly string[] properties;


        protected EntityEventArgs(params TTarget[] targets)
        {
            this.targets = targets;
            this.properties = new string[] { };
        }

        protected EntityEventArgs(TTarget target, params string[] properties)
        {
            this.targets = new[] { target };
            this.properties = properties;
        }


        public TTarget[] Targets
        {
            get { return this.targets; }
        }

        public string[] Properties
        {
            get { return this.properties; }
        } 
    }
}
