﻿using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Text;
using MDownloader.Client.Controllers;
using MDownloader.Main.Client.Services;

namespace MDownloader.Main.Client.Controllers
{
    [Export, PartCreationPolicy(CreationPolicy.NonShared)]
    internal class AddLinksController : ControllerBase, IPartImportsSatisfiedNotification
    {
        [Import]
        private ScheduleServiceProxy scheduleServiceProxy;

        public AddLinksModel Model { get; private set; }


        public void Probe(string text, Action onComplete)
        {
            this.Execute(() =>
            {
                var container = this.scheduleServiceProxy.Probe(text);
                this.Model.Initialize(container);
            }, onComplete);
        }

        public void Queue(Action onComplete)
        {
            var container = this.Model.Container;

            this.Execute(() => this.scheduleServiceProxy.Queue(container), onComplete);
        }


        void IPartImportsSatisfiedNotification.OnImportsSatisfied()
        {
            this.Model = new AddLinksModel();
        }
    }
}
