﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EFramework.Model;
using MDownloader.Main.Entities;

namespace MDownloader.Main.Client.Controllers
{
    internal class CaptchasModel
    {
        private readonly Container container;


        public CaptchasModel()
        {
            this.container = new Container(Guid.NewGuid());
        }


        public Captcha GetCaptcha(Guid captchaId)
        {
            return this.container.Get<Captcha>(captchaId);
        }

        public void AddCaptcha(Guid captchaId, IDictionary<string, string> properties)
        {
            var captcha = new Captcha(captchaId)
            {
                Data = Convert.FromBase64String(properties[CaptchaProperties.Data]),
                Text = properties[CaptchaProperties.Text],
            };

            this.container.Add(captcha);
        }

        public void RemoveCaptcha(Guid captchaId)
        {
            this.container.Remove<Captcha>(captchaId);
        }
    }
}
