﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MDownloader.Main.Entities.Interfaces;

namespace MDownloader.Main.Client.Models.Formatters
{
    internal static class ProgressFormatter
    {
        public static string ToPureSize(this IProgressAware target)
        {
            var result = String.Empty;

            if (target.Size < 1024)
                result = String.Format("{0:F2} B", target.Size);

            if (target.Size < 1024 * 1024)
                result = String.Format("{0:F2} kB", target.Size / 1024f);

            result = String.Format("{0:F2} MB", target.Size / 1024f / 1024f);

            return result;
        }

        public static string ToPureProgress(this IProgressAware target)
        {
            var result = String.Empty;

            if (target.Progress < 1024)
                result = String.Format("{0:F2} B", target.Progress);

            if (target.Progress < 1024 * 1024)
                result = String.Format("{0:F2} kB", target.Progress / 1024f);

            result = String.Format("{0:F2} MB", target.Progress / 1024f / 1024f);

            return result;
        }
    }
}
