﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MDownloader.Main.Entities.Interfaces;

namespace MDownloader.Main.Client.Models.Formatters
{
    internal static class SpeedFormatter
    {
        public static string ToPureSpeed(this ISpeedAware target)
        {
            var result = String.Empty;

            if (target.Speed < 1024)
            {
                result = String.Format("{0:F2} B/s", target.Speed);
            }
            else if (target.Speed < 1024 * 1024)
            {
                result = String.Format("{0:F2} kB/s", target.Speed / 1024f);
            }
            else
            {
                result = String.Format("{0:F2} MB/s", target.Speed / 1024f / 1024f);
            }

            return result;
        }
    }
}
