﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MDownloader.Main.Client.Models.Formatters;
using MDownloader.Main.Client.Models.Interfaces;
using MDownloader.Main.Entities;

namespace MDownloader.Main.Client.Models
{
    internal class LinkViewModel : ResourceBase
    {
        private readonly Link target;


        public LinkViewModel(Link target)
        {
            this.target = target;
        }


        public override Guid Id
        {
            get { return this.target.Identifier.Id; }
        }


        public override string Name
        {
            get { return this.target.Name; }
        }

        public override string Description
        {
            get { return this.target.Description; }
        }

        public override string Provider
        {
            get { return this.target.Provider; }
        }

        public override string State
        {
            get { return this.target.Status.ToString(); }
        }

        public override string Size
        {
            get { return this.target.ToPureSize(); }
        }
    }
}
