﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MDownloader.Client;
using MDownloader.Main.Client.Models.Interfaces;

namespace MDownloader.Main.Client.Models
{
    internal abstract class TaskBase : PropertyNotifier, ITask
    {
        public abstract Guid Id { get; }

        public abstract string Name { get; }
        public abstract string Provider { get; }
        public abstract string State { get; }
        public abstract string Size { get; }
        public abstract string Progress { get; }
        public abstract string Speed { get; }
        
        public bool IsSelected { get; set; }


        public void Update()
        {
            this.RaisePropertyChanged(() => this.State);
            this.RaisePropertyChanged(() => this.Progress);
            this.RaisePropertyChanged(() => this.Speed);
        }


        public override int GetHashCode()
        {
            return this.Id.GetHashCode();
        }

        public override bool Equals(object obj)
        {
            var other = obj as ITask;

            return other != null
                && other.Id == this.Id;
        }
    }
}
