﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MDownloader.Main.Client.Models.Formatters;
using MDownloader.Main.Client.Models.Interfaces;
using MDownloader.Main.Entities;

namespace MDownloader.Main.Client.Models
{
    internal class TaskViewModel : TaskBase
    {
        private readonly Task target;


        public TaskViewModel(Task target)
        {
            this.target = target;
        }


        public override Guid Id
        {
            get { return this.target.Identifier.Id; }
        }


        public override string Name
        {
            get { return this.target.Name; }
        }

        public override string Provider
        {
            get { return this.target.Provider; }
        }

        public override string State
        {
            get 
            {
                if (this.target.Counter == 0)
                {
                    return this.target.Status.ToString();
                }
                else
                {
                    return String.Format("{0} ({1})", this.target.Status, this.target.Counter);
                }
            }
        }

        public override string Size
        {
            get { return this.target.ToPureSize(); }
        }

        public override string Progress
        {
            get { return this.target.ToPureProgress(); }
        }

        public override string Speed
        {
            get { return this.target.ToPureSpeed(); }
        }
    }
}
