﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EFramework.Core.Contracts;
using MDownloader.Client.Operations;
using MDownloader.Main.Client.Controllers;
using MDownloader.Main.Client.Models.Interfaces;
using MDownloader.Main.Client.Operations.Interfaces;

namespace MDownloader.Main.Client.Models.Operations
{
    internal class StartOperation : IOperation
    {
        public string Name
        {
            get { return @"Start"; }
        }

        public bool CanExecute(object context, ICollection<IOperationTarget> targets)
        {
            return targets.Any();
        }

        public void Execute(object context, ICollection<IOperationTarget> targets)
        {
            Ensure.IsNotNull(() => context);
            Ensure.IsNotNull(() => targets);
            Ensure.Is<IResourceExecutionController>(() => context);

            var executionController = context as IResourceExecutionController;
            var resources = targets.Select(x => x.Instance).OfType<IResource>().ToArray();

            executionController.Start(resources);
        }
    }
}
