﻿using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.ServiceModel;
using System.Text;
using EFramework.Model;
using EFramework.Model.Serialization;
using MDownloader.Main.Client.ScheduleServiceReference;

namespace MDownloader.Main.Client.Services
{
    [Export]
    internal class ScheduleServiceProxy
    {
        public Container Probe(string text)
        {
            using (var client = new DownloaderScheduleServiceClient(new NetTcpBinding(), new EndpointAddress("net.tcp://localhost:4712/MDownloader/Main/Schedule")))
            {
                var serializer = new Serializer();
                var settings = new SerializerSettings { PreserveTrackingStates = true };
                var containerType = client.ProbeText(text);
                var container = serializer.Deserialize(containerType, settings);

                return container;
            }
        }

        public void Queue(Container container)
        {
            using (var client = new DownloaderScheduleServiceClient(new NetTcpBinding(), new EndpointAddress("net.tcp://localhost:4712/MDownloader/Main/Schedule")))
            {
                var serializer = new Serializer();
                var settings = new SerializerSettings { PreserveTrackingStates = true };
                var containerType = serializer.Serialize(container, settings);

                client.Queue(containerType);
            }
        }
    }
}
