﻿using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.ServiceModel;
using System.Text;
using MDownloader.Main.Client.TransferServiceReference;
using MDownloader.Main.Entities.Transfer;

namespace MDownloader.Main.Client.Services
{
    [Export]
    internal class TransferServiceProxy
    {
        public void Start(Guid[] resources)
        {
            var query = from resource in resources
                        select new ResourceRef
                        {
                            Id = resource
                        };

            using (var client = new DownloaderTransferServiceClient(new NetTcpBinding(), new EndpointAddress("net.tcp://localhost:4712/MDownloader/Main/Transfer")))
            {
                client.Start(query.ToArray());
            }
        }
    }
}
