﻿using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Text;
using System.Windows.Input;
using MDownloader.Client;
using MDownloader.Client.Interfaces;
using MDownloader.Client.Notifications;
using MDownloader.Main.Client.Views.Interactions;
using MDownloader.Main.Client.Views.Wizards.AddLinks;
using Microsoft.Practices.Prism.Interactivity.InteractionRequest;

namespace MDownloader.Main.Client.Views
{
    [Export, Export(typeof(IModulePanel))]
    [ExportMetadata("Order", 1)]
    [PartCreationPolicy(CreationPolicy.Shared)]
    internal class PanelViewModel : IModulePanel
    {
        [Import]
        private IServiceProvider serviceProvider;


        private readonly DelegateCommand addCommand;
        private readonly InteractionRequest<Interaction<IAddWizardConnector>> addWizardRequest;

        public PanelViewModel()
        {
            this.addCommand = new DelegateCommand(this.OnAddCommand);
            this.addWizardRequest = new InteractionRequest<Interaction<IAddWizardConnector>>();
        }


        public string Header
        {
            get { return "Main"; }
        }

        public IServiceProvider ServiceProvider
        {
            get { return this.serviceProvider; }
        }


        public ICommand AddCommand
        {
            get { return this.addCommand; }
        }

        private void OnAddCommand()
        {
            this.addWizardRequest.Raise(new Interaction<IAddWizardConnector>(), interaction =>
            {
                var connector = interaction.Connector;
            });
        }

        public IInteractionRequest AddWizardRequest
        {
            get { return this.addWizardRequest; }
        }

        [Import]
        public QueueViewModel Queue { get; private set; }

        [Import]
        public TasksViewModel Tasks { get; private set; }
    }
}
