﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel.Composition;
using System.Linq;
using System.Text;
using MDownloader.Client;
using MDownloader.Client.Controllers;
using MDownloader.Main.Client.Controllers;
using MDownloader.Main.Client.Models;
using MDownloader.Main.Client.Models.Interfaces;

namespace MDownloader.Main.Client.Views.Wizards.AddLinks
{
    [Export, PartCreationPolicy(CreationPolicy.NonShared)]
    internal class LinksViewModel : PropertyNotifier
    {
        [Import]
        private ControllerRegistry controllerRegistry;
        private AddLinksController controller;


        public ExecutionNotifier Executor
        {
            get { return this.controller.Executor; }
        }

        public ICollection<IResource> Links { get; set; }

        public bool CanFinish
        {
            get { return !this.Executor.IsBusy && this.Links.Count > 0; }
        }


        public void Initialize(Guid id)
        {
            this.controller = this.controllerRegistry.GetController<AddLinksController>(id);
            this.Links = new ObservableCollection<IResource>();
        }

        public void Initialize(string text)
        {
            this.controller.Probe(text, () =>
            {
                foreach (var link in this.controller.Model.GetLinks())
                {
                    this.Links.Add(new LinkViewModel(link));
                }

                this.RaisePropertyChanged(() => this.CanFinish);
            });
        }
    }
}
