﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EFramework.Model;
using MDownloader.Main.Entities.Interfaces;

namespace MDownloader.Main.Entities
{
    public class Link : Entity, ISizeAware
    {
        public Link(Guid id)
            : base(Identifier.From<Link>(id))
        {
        }


        public string Name { get; set; }
        public string Description { get; set; }
        public string Provider { get; set; }

        public long Size { get; set; }
        public bool SizeExactness { get; set; }

        public LinkFlags Flags { get; set; }

        private LinkStatus status;
        public LinkStatus Status
        {
            get { return this.status; }
            set
            {
                if (this.status != value)
                {
                    this.status = value;
                    this.OnChanged(LinkProperties.Status);
                }
            }
        }


        public enum LinkStatus : int
        {
            Idle,
            Queued,
            Working,
            Completed,
        }

        public enum LinkFlags : long
        {
        }
    }
}
