﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EFramework.Model;
using MDownloader.Main.Entities.Interfaces;

namespace MDownloader.Main.Entities
{
    public class Task : Entity, IProgressAware, ISpeedAware
    {
        public Task(Guid id)
            : base(Identifier.From<Task>(id))
        {
        }


        public string Provider { get; set; }
        public string Name { get; set; }

        public long Size { get; set; }

        private long progress;
        public long Progress
        {
            get { return this.progress; }
            set
            {
                if (this.progress != value)
                {
                    this.progress = value;
                    this.OnChanged(TaskProperties.Progress);
                }
            }
        }

        public long speed;
        public long Speed
        {
            get { return this.speed; }
            set
            {
                if (this.speed != value)
                {
                    this.speed = value;
                    this.OnChanged(TaskProperties.Speed);
                }
            }
        }

        private TaskStatus status;
        public TaskStatus Status
        {
            get { return this.status; }
            set
            {
                if (this.status != value)
                {
                    this.status = value;
                    this.OnChanged(TaskProperties.Status);
                }
            }
        }

        private int counter;
        public int Counter
        {
            get { return this.counter; }
            set
            {
                if (this.counter != value)
                {
                    this.counter = value;
                    this.OnChanged(TaskProperties.Counter);
                }
            }
        }


        public enum TaskStatus : int
        {
            Idle,
            Working,
            Waiting,
            Captcha,
            Downloading,
        }
    }
}
