﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EFramework.Core.Contracts;

namespace MDownloader.Main.Interfaces.Base.Feedbacks
{
    public sealed class CaptchaFeedback : IProviderFeedback
    {
        private readonly Action onComplete;
        private readonly ICaptcha captcha;


        public CaptchaFeedback(ICaptcha captcha, Action onComplete)
        {
            Ensure.IsNotNull(() => captcha);
            Ensure.IsNotNull(() => onComplete);

            this.captcha = captcha;
            this.onComplete = onComplete;
        }

        
        public bool IsReady()
        {
            return false;
        }

        public bool IsWaitingRequired()
        {
            return false;
        }

        public void SatisfyWaitingRequirement(Action<TimeSpan> waiter)
        {
        }

        public bool IsCaptchaRequired()
        {
            return true;
        }

        public void SatisfyCaptchaRequirement(Action<ICaptcha> captcher)
        {
            captcher(this.captcha);
            this.onComplete();
        }
    }
}
