﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EFramework.Core.Contracts;

namespace MDownloader.Main.Interfaces.Base.Feedbacks
{
    public sealed class WaitFeedback : IProviderFeedback
    {
        private readonly Action onComplete;
        private readonly TimeSpan period;


        public WaitFeedback(TimeSpan period, Action onComplete)
        {
            Ensure.IsNotNull(() => onComplete);

            this.period = period;
            this.onComplete = onComplete;
        }

        public bool IsReady()
        {
            return false;
        }

        public bool IsWaitingRequired()
        {
            return true;
        }

        public void SatisfyWaitingRequirement(Action<TimeSpan> waiter)
        {
            Ensure.IsNotNull(() => waiter);

            waiter(this.period);
            this.onComplete();
        }

        public bool IsCaptchaRequired()
        {
            return false;
        }

        public void SatisfyCaptchaRequirement(Action<ICaptcha> captcher)
        {
        }
    }
}
