﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace MDownloader.Main.Interfaces.Base
{
    public abstract class SchedulerBase
    {
        private int count;


        public event EventHandler Changed;
        private void OnChanged()
        {
            var handler = this.Changed;
            var args = EventArgs.Empty;

            if (handler != null)
            {
                handler(this, args);
            }
        }


        public ISchedulerToken GetToken()
        {
            if (this.count > 0)
                return null;

            this.count++;
            return new SchedulerToken(this.Release);
        }

        private void Release(ISchedulerToken token)
        {
            this.count--;

            if (this.count == 0)
            {
                this.OnChanged();
            }
        }
    }
}
