﻿using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Text;
using EFramework.Networking;
using MDownloader.Core.Server;
using MDownloader.Main.Interfaces;
using MDownloader.Main.Server.Browser.Interfaces;

namespace MDownloader.Main.Server.Browser.Implementation
{
    [Export(typeof(IBrowserFactory))]
    [Export(typeof(IBrowserFactoryInternal))]
    [PartCreationPolicy(CreationPolicy.Shared)]
    internal class BrowserFactory : IBrowserFactoryInternal
    {
        private readonly NetworkService service;
        private readonly NetworkGateway gateway;


        public BrowserFactory()
        {
            this.service = new NetworkService();
            this.gateway = service.CreateGateway();
        }


        public IBrowser CreateBrowser()
        {
            return new Browser(this.gateway);
        }
    }
}
