﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using EFramework.Networking;
using EFramework.Networking.Parser;
using MDownloader.Core.Server;

namespace MDownloader.Main.Server.Browser.Implementation
{
    internal class BrowserSession : IBrowserSession
    {
        private readonly NetworkGateway gateway;


        public BrowserSession(NetworkGateway gateway)
        {
            this.gateway = gateway;
        }


        public HDocument GetPage(NetworkRequest request)
        {
            return this.gateway.GetPage(request);
        }

        public string GetText(NetworkRequest request)
        {
            return this.gateway.GetText(request);
        }

        public byte[] GetImage(NetworkRequest request)
        {
            return this.gateway.GetImage(request);
        }

        public Stream GetStream(NetworkRequest request)
        {
            return this.gateway.GetStream(request);
        }
    }
}
