﻿using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Text;
using MDownloader.Main.Interfaces;
using MDownloader.Main.Server.Engine.Interfaces;
using MDownloader.Main.Server.Model.Interfaces;
using MDownloader.Main.Server.Persistence.Interfaces;
using MDownloader.Main.Server.Services.Interfaces;

namespace MDownloader.Main.Server.Engine.Implementation
{
    [Export(typeof(IEngine))]
    [Export(typeof(IEngineInternal))]
    [PartCreationPolicy(CreationPolicy.Shared)]
    internal class Engine : IEngineInternal
    {
        [Import]
        private IPersisterInternal persister;

        [Import]
        private IModelInternal model;

        [ImportMany]
        private Lazy<IServiceHostFactory>[] hosts;

        public void Initialize()
        {
            this.persister.Initialize();
            this.model.Initialize();

            foreach (var host in this.hosts)
            {
                host.Value.Initialize();
                host.Value.Start();
            }
        }

        public void Start()
        {
        }
    }
}
