﻿using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Text;
using System.Threading;
using MDownloader.Main.Interfaces;
using MDownloader.Main.Server.Executor.Interfaces;

namespace MDownloader.Main.Server.Executor.Implementation
{
    [Export(typeof(IExecutor))]
    [Export(typeof(IExecutorInternal))]
    [PartCreationPolicy(CreationPolicy.Shared)]
    internal class Executor : IExecutorInternal
    {
        public void Queue<TContext>(TContext context, params IExecutorTask<TContext>[] tasks)
        {
            foreach (var task in tasks)
            {
                ThreadPool.QueueUserWorkItem(task.Callback, context);
            }
        }

        public void Execute<TContext>(TContext context, params IExecutorTask<TContext>[] tasks)
        {
            foreach (var task in tasks)
            {
                ThreadPool.QueueUserWorkItem(task.Callback, context);
            }

            foreach (var task in tasks)
            {
                task.Handle.WaitOne();
            }
        }
    }
}
