﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using MDownloader.Main.Entities.Transfer;

namespace MDownloader.Main.Server
{
    /// <summary>
    /// Provides operations to manage artifacts.
    /// </summary>
    [ServiceContract]
    public interface IDownloaderManageService
    {
        /// <summary>
        /// Sets the new priority of given resources.
        /// </summary>
        /// <param name="priority">The priority to set.</param>
        /// <param name="resources">The resources to affect.</param>
        [OperationContract]
        void SetPriority(int priority, ResourceRef[] resources);

        /// <summary>
        /// Removes the given resources.
        /// </summary>
        /// <param name="resources">The resources to remove.</param>
        [OperationContract]
        void Remove(ResourceRef[] resources);
    }
}
