﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using EFramework.Model.Transfer;

namespace MDownloader.Main.Server
{
    /// <summary>
    /// Provides operations to work with scheduler.
    /// </summary>
    [ServiceContract]
    public interface IDownloaderScheduleService
    {
        /// <summary>
        /// Probes all links found in the given text.
        /// </summary>
        /// <param name="text">The text to search in.</param>
        /// <returns>Probe result.</returns>
        [OperationContract(Name = "ProbeText")]
        ContainerType Probe(string text);

        /// <summary>
        /// Probes all the given urls.
        /// </summary>
        /// <param name="containerType">The all urls containers.</param>
        /// <returns>Probe result.</returns>
        [OperationContract]
        ContainerType Probe(ContainerType containerType);

        /// <summary>
        /// Queues all links, file and packages.
        /// </summary>
        /// <param name="containerType">The artifacts to queue.</param>
        [OperationContract]
        void Queue(ContainerType containerType);
    }
}
