﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using MDownloader.Main.Entities.Transfer;

namespace MDownloader.Main.Server
{
    /// <summary>
    /// Provides operations to work with working tasks.
    /// </summary>
    [ServiceContract]
    public interface IDownloaderTransferService
    {
        /// <summary>
        /// Starts proceeding given resources.
        /// </summary>
        /// <param name="resources">The resources to start.</param>
        [OperationContract]
        void Start(params ResourceRef[] resources);

        /// <summary>
        /// Stop proceeding given tasks.
        /// </summary>
        /// <param name="tasks">The tasks to stop.</param>
        [OperationContract]
        void Stop(params TaskRef[] tasks);
    }
}
