﻿using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Text;
using EFramework.Model;
using MDownloader.Main.Entities;
using MDownloader.Main.Server.Matcher.Interfaces;
using MDownloader.Main.Server.Model.Interfaces;
using MDownloader.Main.Server.Filer.Interfaces;

namespace MDownloader.Main.Server.Matcher.Implementation
{
    [Export(typeof(IMatcherInternal))]
    internal class Matcher : IMatcherInternal
    {
        [Import]
        private IModelInternal model;

        [Import]
        private IFilerInternal filer;


        public void AssignFiles(IList<Package<Link>> packages)
        {
            var files = this.model.GetFiles();

            foreach (var package in packages)
            {
                var link = package.Leader();
                var location = this.filer.GetFileLocation(package);

                var file = new File(Guid.NewGuid())
                {
                    Name = link.Name,
                    Size = link.Size,
                    SizeExactness = link.SizeExactness,
                    Location = location,
                    Progress = 0L,
                };

                file.Add(link.Identifier);
                link.Add(file.Identifier);

                package.Add(file);
            }
        }
    }
}
