﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EFramework.Model;

namespace MDownloader.Main.Server.Model.Implementation
{
    internal abstract class ResourceWorker
    {
        private readonly HashSet<Identifier> touched;
        private readonly HashSet<Entity> entities;


        protected ResourceWorker()
        {
            this.touched = new HashSet<Identifier>();
            this.entities = new HashSet<Entity>();
        }


        protected bool Contains(Identifier identifier)
        {
            return this.touched.Contains(identifier);
        }

        protected void Add(Entity entity)
        {
            this.touched.Add(entity.Identifier);
            this.entities.Add(entity);
        }


        internal TEntity[] GetAll<TEntity>()
            where TEntity : Entity
        {
            return this.entities.OfType<TEntity>().ToArray();
        }
    }
}
