﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EFramework.Model;
using MDownloader.Main.Entities;

namespace MDownloader.Main.Server.Model.Interfaces
{
    internal interface IModelInternal
    {
        event EventHandler<LinkEventArgs> LinkAdded;
        event EventHandler<LinkEventArgs> LinkChanged;
        event EventHandler<LinkEventArgs> LinkRemoved;

        event EventHandler<TaskEventArgs> TaskAdded;
        event EventHandler<TaskEventArgs> TaskChanged;
        event EventHandler<TaskEventArgs> TaskRemoved;

        void Add(Package<Link>[] packages);
        void Add(Package<Task>[] packages);

        void Remove(Guid[] resources);
        void Remove(Task task);

        File[] GetFiles();
        Link[] GetLinks(Guid[] resources);
        LinkPath GetPath(Link link);

        void Initialize();
        void Flush(IFlushSink flushSink);
    }
}
