﻿using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using MDownloader.Main.Server.Parser.Interfaces;

namespace MDownloader.Main.Server.Parser.Implementation
{
    [Export(typeof(IParserInternal))]
    [PartCreationPolicy(CreationPolicy.Shared)]
    internal class Parser : IParserInternal
    {
        private static Regex UriRegex = new Regex(@"(?i)\b((?:[a-z][\w-]+:(?:/{1,3}|[a-z0-9%])|www\d{0,3}[.]|[a-z0-9.\-]+[.][a-z]{2,4}/)(?:[^\s()<>]+|\(([^\s()<>]+|(\([^\s()<>]+\)))*\))+(?:\(([^\s()<>]+|(\([^\s()<>]+\)))*\)|[^\s`!()\[\]{};:'" + '"' + @".,<>?«»“”‘’]))", RegexOptions.IgnoreCase);


        public IEnumerable<string> FindLinks(string text)
        {
            var matches = Parser.UriRegex.Matches(text);

            foreach (Match match in matches)
            {
                yield return match.Value;
            }            
        }
    }
}
