﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MDownloader.Main.Interfaces;
using NHibernate;

namespace MDownloader.Main.Server.Persistence.Implementation
{
    internal class PersistenceSession : IPersisterSession
    {
        private readonly ISessionFactory sessionFactory;
        private ISession current;

        public PersistenceSession(ISessionFactory sessionFactory)
        {
            this.sessionFactory = sessionFactory;
            this.current = this.sessionFactory.OpenSession();
        }


        public ISession Current
        {
            get { return this.current; }
        }


        public void Dispose()
        {
            this.current.Close();
            this.current.Dispose();
        }
    }
}
