﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MDownloader.Main.Entities;

namespace MDownloader.Main.Server.Repository.Extensions
{
    internal static class LinkExtensions
    {
        public static Link ToEntity(this LinkType target, LinkScope scope)
        {
            return new Link(target.Id)
            {
            };
        }

        public static LinkType ToType(this Link target, LinkScope scope, Url url)
        {
            var linkType = new LinkType
            {
                Id = target.Identifier.Id,
            };

            if (scope.HasFlag(LinkScope.Basic))
            {
                linkType.Target = url.Target;
                linkType.Provider = target.Provider;
            }

            if (scope.HasFlag(LinkScope.Description))
            {
                linkType.Name = target.Name;
                linkType.Description = target.Description;
            }

            if (scope.HasFlag(LinkScope.Size))
            {
                linkType.Size = target.Size;
                linkType.SizeExactness = target.SizeExactness;
            }

            if (scope.HasFlag(LinkScope.Flags))
            {
                linkType.Flags = (long)target.Flags;
                linkType.Status = (int)target.Status;
            }

            return linkType;
        }
    }
}
