﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MDownloader.Main.Server.Repository.Interfaces;

namespace MDownloader.Main.Server.Repository.Implementation
{
    internal static class PartManager
    {
        private static readonly Dictionary<Type, object> entries;


        static PartManager()
        {
            var query = from type in typeof(PartManager).Assembly.GetTypes()
                        where type.IsDefined(typeof(PartAttribute), false)
                        from attribute in type.GetCustomAttributes(typeof(PartAttribute), false).OfType<PartAttribute>()
                        select new
                        {
                            Type = type,
                            Part = attribute.Type,
                        };

            PartManager.entries = query.ToDictionary(x => x.Part, x => Activator.CreateInstance(x.Type));
        }

        public static IPart<T> Get<T>()
            where T : class, IType, new()
        {
            return (IPart<T>)PartManager.entries[typeof(T)];
        }
    }
}
