﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MDownloader.Main.Server.Repository.Interfaces;

namespace MDownloader.Main.Server.Repository.Implementation
{
    public class ScopeManager : IScopeManager
    {
        private readonly Dictionary<Type, Enum> entries;


        public ScopeManager(params Enum[] scopes)
        {
            this.entries = new Dictionary<Type, Enum>();

            foreach (var scope in scopes)
            {
                this.entries.Add(scope.GetType(), scope);
            }
        }


        public void Add<TEnum>(TEnum value)
        {
            this.entries.Add(typeof(TEnum), (Enum)(object)value);
        }

        public TEnum Get<TEnum>()
        {
            if (this.entries.ContainsKey(typeof(TEnum)))
            {
                return (TEnum)(object)this.entries[typeof(TEnum)];
            }
            else
            {
                return default(TEnum);
            }
        }
    }
}
