﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MDownloader.Main.Interfaces;

namespace MDownloader.Main.Server.Scheduler
{
    internal class ReadyEventArgs : EventArgs
    {
        private readonly IScheduler scheduler;
        private readonly ISchedulerToken token;
        private readonly DownloadTask[] tasks;


        public ReadyEventArgs(IScheduler scheduler, ISchedulerToken token, DownloadTask[] tasks)
        {
            this.scheduler = scheduler;
            this.token = token;
            this.tasks = tasks;
        }


        public IScheduler Scheduler
        {
            get { return this.scheduler; }
        }

        public ISchedulerToken Token
        {
            get { return this.token; }
        }

        public DownloadTask[] Tasks
        {
            get { return this.tasks; }
        }
    }
}
