﻿using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Text;
using MDownloader.Main.Entities.Transfer;
using MDownloader.Main.Server.Model.Interfaces;
using MDownloader.Main.Server.Scheduler.Interfaces;

namespace MDownloader.Main.Server.Services.Endpoints
{
    [Export(typeof(IDownloaderTransferService))]
    [PartCreationPolicy(CreationPolicy.Shared)]
    internal class DownloaderTransferService : IDownloaderTransferService
    {
        [Import]
        private IModelInternal model;

        [Import]
        private ISchedulerInternal scheduler;


        public void Start(params ResourceRef[] resources)
        {
            var query = from resource in resources
                        select resource.Id;

            var links = this.model.GetLinks(query.ToArray());
            this.scheduler.Queue(links);
        }

        public void Stop(params TaskRef[] tasks)
        {
        }
    }
}
