﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using MDownloader.Main.Entities;
using MDownloader.Main.Entities.Transfer;

namespace MDownloader.Main.Server.Services.Implementation.Builders
{
    internal class CaptchaBuilder
    {
        public CaptchaChange[] BuildAdds(Captcha[] captchas)
        {
            var changes = new List<CaptchaChange>(captchas.Length);

            foreach (var captcha in captchas)
            {
                changes.Add(new CaptchaChange
                {
                    Change = ChangeType.Added,
                    Ref = new CaptchaRef
                    {
                        Id = captcha.Identifier.Id
                    },
                    Properties = new Dictionary<string, string>
                    {
                        { CaptchaProperties.Data, Convert.ToBase64String(captcha.Data) },
                        { CaptchaProperties.Text, captcha.Text },
                    }
                });
            }

            return changes.ToArray();
        }

        public CaptchaChange[] BuildRemoves(Captcha[] captchas)
        {
            var changes = new List<CaptchaChange>(captchas.Length);

            foreach (var captcha in captchas)
            {
                changes.Add(new CaptchaChange
                {
                    Change = ChangeType.Removed,
                    Ref = new CaptchaRef
                    {
                        Id = captcha.Identifier.Id
                    }
                });
            }

            return changes.ToArray();
        }
    }
}
