﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MDownloader.Main.Entities;
using MDownloader.Main.Server.Model.Interfaces;
using MDownloader.Main.Server.Services.Implementation.Builders;

namespace MDownloader.Main.Server.Services.Implementation
{
    internal class CallbackFlushSink : IFlushSink
    {
        private readonly IDownloaderCallback callback;


        public CallbackFlushSink(IDownloaderCallback callback)
        {
            this.callback = callback;
        }


        public void OnLinkAdded(Link[] links)
        {
            var builder = new LinkBuilder();
            var changes = builder.BuildAdds(links);

            this.callback.OnLinkChanged(changes);
        }
    }
}
