﻿using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Text;
using MDownloader.Main.Server.Services.Interfaces;

namespace MDownloader.Main.Server.Services.Implementation
{
    [Export(typeof(ICallbackRepositoryInternal))]
    [PartCreationPolicy(CreationPolicy.Shared)]
    internal class CallbackRepository : ICallbackRepositoryInternal
    {
        private readonly HashSet<IDownloaderCallback> entries;


        public CallbackRepository()
        {
            this.entries = new HashSet<IDownloaderCallback>();
        }


        public void AddCallback(IDownloaderCallback callback)
        {
            this.entries.Add(callback);
        }

        public void RemoveCallback(IDownloaderCallback callback)
        {
            this.entries.Remove(callback);
        }

        public IDownloaderCallback[] GetAll()
        {
            return this.entries.ToArray();
        }
    }
}
