﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace MDownloader.Main.Server.Writer.Implementation
{
    internal class Counter
    {
        private readonly List<Entry> entries;


        public Counter()
        {
            this.entries = new List<Entry>();
        }


        public void Tick(long value)
        {
            this.entries.Add(new Entry { Timestamp = DateTime.Now, Value = value });
        }

        public long Calculate()
        {
            var oldest = DateTime.Now.Subtract(TimeSpan.FromSeconds(5));
            var query = from entry in this.entries
                        where entry.Timestamp > oldest
                        select entry;

            if (query.Any())
            {
                return query.Sum(x => x.Value) / 5;
            }
            else
            {
                return 0L;
            }
        }


        private class Entry
        {
            public DateTime Timestamp;
            public long Value;
        }
    }
}
