﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using MDownloader.Main.Server.Writer.Interfaces;

namespace MDownloader.Main.Server.Writer.Implementation
{
    internal class MultiStream : IMultiStream
    {
        private readonly MultiStreamMap map;


        public MultiStream(string location)
        {
            this.map = new MultiStreamMap(location);
        }


        public void Compact(string destination)
        {
        }

        public void CopyTo(string destination)
        {
        }
        

        public void Write(Stream stream, long offset, long count, Action<ITick> progress)
        {
            using (var multiStreamLock = this.map.Lock(offset, count))
            using (var buffer = new Buffer())
            {
                var ranges = this.map.List(multiStreamLock);
                foreach (var range in ranges)
                {
                    range.Write(stream, buffer, progress);
                }

                map.Flush(ranges);
            }
        }

        public IMultiStreamInfo GetInfo()
        {
            return this.map;
        }
    }
}
