﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MDownloader.Main.Server.Writer.Interfaces;

namespace MDownloader.Main.Server.Writer.Implementation
{
    internal class MultiStreamLock : IMultiStreamLock
    {
        private readonly IMultiStreamLockOwner owner;
        private readonly long start;
        private readonly long count;


        public MultiStreamLock(IMultiStreamLockOwner owner, long start, long count)
        {
            this.owner = owner;
            this.start = start;
            this.count = count;
        }


        public long Start
        {
            get { return this.start; }
        }

        public long Count
        {
            get { return this.count; }
        }


        public void Dispose()
        {
            this.owner.Release(this);
        }
    }
}
