﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using MDownloader.Main.Server.Writer.Interfaces;

namespace MDownloader.Main.Server.Writer.Implementation
{
    internal class MultiStreamRange
    {
        private readonly Counter counter;
        private readonly string location;
        private readonly FileStream file;
        private readonly long offset;
        private readonly long count;
        private long capacity;
        private long read;


        public MultiStreamRange(string location, FileStream file, long offset, long count)
        {
            this.counter = new Counter();
            this.location = location;
            this.file = file;
            this.offset = offset;
            this.count = count;
            this.capacity = count;
        }


        public string Location
        {
            get { return this.location; }
        }


        public void Write(Stream stream, Buffer buffer, Action<ITick> progress = null)
        {
            file.Seek(offset, SeekOrigin.Begin);

            while (this.capacity > 0)
            {
                buffer.Fill(stream, this.capacity, counter.Tick);
                this.read = buffer.Flush(file);
                this.capacity -= this.read;

                if (progress != null)
                {
                    progress.BeginInvoke(new Tick(this.count - this.capacity, counter.Calculate()), null, null);
                }
            }
        }
    }
}
