﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MDownloader.Client;
using MDownloader.Search.Client.Models.Interfaces;
using MDownloader.Search.Client.Models.Formatters;
using MDownloader.Search.Entities;

namespace MDownloader.Search.Client.Models
{
    internal class ResultViewModel : PropertyNotifier, IResult
    {
        private readonly Result target;


        public ResultViewModel(Result target)
        {
            this.target = target;
        }


        public Guid Id
        {
            get { return this.target.Identifier.Id; }
        }

        public string Name
        {
            get { return this.target.Name; }
        }

        public string Provider
        {
            get { return this.target.Provider; }
        }

        public int Files
        {
            get { return this.target.Files; }
        }

        public string Size
        {
            get { return this.target.ToPureSize(); }
        }

        public string State
        {
            get { return this.target.Status.ToString(); }
        }

        public void Update()
        {
            this.RaisePropertyChanged(() => this.Size);
            this.RaisePropertyChanged(() => this.State);
        }
    }
}
