﻿using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.ServiceModel;
using System.Text;
using EFramework.Model;
using EFramework.Model.Serialization;
using MDownloader.Search.Client.EngineServiceReference;

namespace MDownloader.Search.Client.Services
{
    [Export]
    internal class EngineServiceProxy
    {
        public void Search(Container container)
        {
            using (var client = new SearchEngineServiceClient(new NetTcpBinding(), new EndpointAddress("net.tcp://localhost:4712/MDownloader/Search/Engine")))
            {
                var serializer = new Serializer();
                var settings = new SerializerSettings { PreserveTrackingStates = true };
                var containerType = serializer.Serialize(container, settings);

                client.Search(containerType);
            }
        }
    }
}
