﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EFramework.Model;
using MDownloader.Search.Entities.Interfaces;

namespace MDownloader.Search.Entities
{
    public class Result : Entity, ISizeAware
    {
        public Result(Guid id)
            : base(Identifier.From<Result>(id))
        {
        }

        public string Name { get; set; }
        public string Provider { get; set; }
        public int Files { get; set; }

        private long size;
        public long Size
        {
            get { return this.size; }
            set
            {
                if (this.size != value)
                {
                    this.size = value;
                    this.OnChanged(ResultProperties.Size);
                }
            }
        }

        private bool sizeExactness;
        public bool SizeExactness
        {
            get { return this.sizeExactness; }
            set
            {
                if (this.sizeExactness != value)
                {
                    this.sizeExactness = value;
                    this.OnChanged(ResultProperties.SizeExactness);
                }
            }
        }


        private ResultStatus status;
        public ResultStatus Status
        {
            get { return this.status; }
            set
            {
                if (this.status != value)
                {
                    this.status = value;
                    this.OnChanged(ResultProperties.Status);
                }
            }
        }


        public enum ResultStatus : int
        {
            Idle,
            Querying,
            Ready,
        }
    }
}
