﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MDownloader.Search.Entities;

namespace MDownloader.Search.Server.Model
{
    internal class ResultEventArgs : EventArgs
    {
        private readonly Result[] targets;
        private readonly string[] properties;


        public ResultEventArgs(params Result[] targets)
        {
            this.targets = targets;
            this.properties = new string[] { };
        }

        public ResultEventArgs(Result target, params string[] properties)
        {
            this.targets = new[] { target };
            this.properties = properties;
        }


        public Result[] Targets
        {
            get { return this.targets; }
        }

        public string[] Properties
        {
            get { return this.properties; }
        }
    }
}
