﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MDownloader.Search.Entities;

namespace MDownloader.Search.Server.Model
{
    internal class SpecificationEventArgs : EventArgs
    {
        private readonly Specification[] targets;
        private readonly string[] properties;


        public SpecificationEventArgs(params Specification[] targets)
        {
            this.targets = targets;
            this.properties = new string[] { };
        }

        public SpecificationEventArgs(Specification target, params string[] properties)
        {
            this.targets = new[] { target };
            this.properties = properties;
        }


        public Specification[] Targets
        {
            get { return this.targets; }
        }

        public string[] Properties
        {
            get { return this.properties; }
        }
    }
}
