﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MDownloader.Search.Interfaces;

namespace MDownloader.Search.Server.Scheduler
{
    internal class SearchQuery : ISearchQuery
    {
        private readonly string searchText;
        private readonly Dictionary<string, string> parameters;


        public SearchQuery(string searchText)
        {
            this.searchText = searchText;
            this.parameters = new Dictionary<string, string>();
        }


        public void AddParameter(string key, string value)
        {
            this.parameters.Add(key, value);
        }


        public string GetSearchText()
        {
            return this.searchText;
        }

        public IEnumerable<ISearchParameter> GetParameters()
        {
            var query = from parameter in this.parameters
                        select new SearchParameter
                        {
                            Key = parameter.Key,
                            Value = parameter.Value,
                        };

            return query;
        }
    }
}
