﻿using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Text;
using EFramework.Model.Serialization;
using EFramework.Model.Splitting;
using EFramework.Model.Transfer;
using MDownloader.Search.Entities;
using MDownloader.Search.Server.Model.Interfaces;
using MDownloader.Search.Server.Scheduler.Interfaces;

namespace MDownloader.Search.Server.Services.Endpoints
{
    [Export(typeof(ISearchEngineService))]
    [PartCreationPolicy(CreationPolicy.Shared)]
    internal class SearchEngineService : ISearchEngineService
    {
        [Import]
        private IModelInternal model;

        [Import]
        private ISchedulerInternal scheduler;


        public void Search(ContainerType query)
        {
            var serializer = new Serializer();
            var serializerSettings = new SerializerSettings { PreserveTrackingStates = true };
            var container = serializer.Deserialize(query, serializerSettings);

            var splitSettings = new SplitSettings { CloneEntities = false };
            var packages = container.Split<Specification>(splitSettings);

            foreach (var package in packages)
            {
                this.model.Add(package);
                this.scheduler.Queue(package.Leader());
            }
        }
    }
}
