﻿using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Text;
using MDownloader.Search.Server.Services.Interfaces;

namespace MDownloader.Search.Server.Services.Implementation
{
    [Export(typeof(ICallbackRepositoryInternal))]
    [PartCreationPolicy(CreationPolicy.Shared)]
    internal class CallbackRepository : ICallbackRepositoryInternal
    {
        private readonly HashSet<ISearchCallback> entries;


        public CallbackRepository()
        {
            this.entries = new HashSet<ISearchCallback>();
        }


        public void AddCallback(ISearchCallback callback)
        {
            this.entries.Add(callback);
        }

        public void RemoveCallback(ISearchCallback callback)
        {
            this.entries.Remove(callback);
        }

        public ISearchCallback[] GetAll()
        {
            return this.entries.ToArray();
        }
    }
}
