﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.ServiceModel.Dispatcher;
using System.Text;

namespace MDownloader.Server.Services
{
    public class InstanceProvider : IInstanceProvider
    {
        private readonly Type serviceType;
        private readonly IServiceProvider serviceProvider;


        public InstanceProvider(Type serviceType, IServiceProvider serviceProvider)
        {
            this.serviceProvider = serviceProvider;
            this.serviceType = serviceType;
        }


        public object GetInstance(InstanceContext instanceContext, Message message)
        {
            return this.serviceProvider.GetService(this.serviceType);
        }

        public object GetInstance(InstanceContext instanceContext)
        {
            return this.serviceProvider.GetService(this.serviceType);
        }

        public void ReleaseInstance(InstanceContext instanceContext, object instance)
        {
        }
    }
}
