﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel.Composition;
using System.Linq;
using System.Text;
using MDownloader.Client.Interfaces;

namespace MDownloader
{
    [Export]
    internal class ShellViewModel : IPartImportsSatisfiedNotification
    {
        [ImportMany]
        private Lazy<IModulePanel, IModulePanelMetadata>[] panels;

        [Import]
        private ICaptchaPanel captchas;


        public object Captchas
        {
            get { return captchas; }
        }

        public ICollection<IModulePanel> Panels { get; private set; }

        
        void IPartImportsSatisfiedNotification.OnImportsSatisfied()
        {
            var query = from panel in this.panels
                        orderby panel.Metadata.Order ascending
                        select panel.Value;

            this.Panels = new ObservableCollection<IModulePanel>(query);
        }
    }
}
