﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using EFramework.Networking;
using EFramework.Networking.Parser;

namespace QImpl.Core.Exceptions.UnexpectedData
{
    public class ArtifactFactory
    {
        internal ArtifactFactory()
        {
        }


        public Artifact Create(HDocument document)
        {
            return new DocumentArtifact(document);
        }

        public Artifact Create(NetworkCallback callback)
        {
            return new CallbackArtifact(callback);
        }

        public Artifact Create(string text)
        {
            return new TextArtifact(text);
        }

        public Artifact Create(byte[] data)
        {
            return new BinaryArtifact(data);
        }

        public Artifact Create(Stream stream)
        {
            return new StreamArtifact(stream);
        }
    }
}
