﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EFramework.Networking.Parser;

namespace QImpl.Responses.Document
{
    public abstract class DocumentProcessorBase<TResponse, TElement> : DocumentProcessor<TResponse>
        where TResponse : IResponsePart
        where TElement : class
    {
        public override void Process(TResponse response, HDocument document)
        {
            var query = this.GetQuery();
            var element = query(document);

            if (this.Validate(element) == true)
            {
                this.Execute(response, element);
            }
        }

        protected virtual bool Validate(TElement element)
        {
            return element != null;
        }

        protected abstract Func<HDocument, TElement> GetQuery();
        protected abstract void Execute(TResponse response, TElement element);
    }
}
