﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace QImpl.Responses.Document
{
    public abstract class DocumentProcessorList<TResponse, TElement, TRow> : DocumentProcessorBase<TResponse, TElement>
        where TResponse : ResponsePartBase
        where TElement : class
        where TRow : class
    {
        protected sealed override void Execute(TResponse response, TElement element)
        {
            this.Initialize(response);

            foreach (var row in this.GetRows(element))
            {
                this.Execute(response, row);
            }
        }

        protected abstract IEnumerable<TRow> GetRows(TElement element);

        protected abstract void Initialize(TResponse response);
        protected abstract void Execute(TResponse response, TRow row);
    }
}
