﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EFramework.Core.Contracts;
using MDownloader.Core.Server;
using MDownloader.Main.Interfaces;

namespace QImpl.FileSonic.Implementation
{
    internal class Session : IProviderSession
    {
        private readonly IBrowser browser;


        public Session(IBrowser browser)
        {
            Ensure.IsNotNull(() => browser);

            this.browser = browser;
        }


        public ICollection<IProviderLink> Analyze(ICollection<string> links)
        {
            var result = new List<IProviderLink>(links.Count);
            var session = this.browser.OpenSession();

            return result;
        }

        public IProviderResource Download(string link)
        {
            return new Resource(browser.OpenSession(), link);
        }

        public void Dispose()
        {
        }
    }
}
