﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using MDownloader.Main.Interfaces.Base;

namespace QImpl.FileSonic.Implementation
{
    // http://www.filesonic.pl/file/u2ELZVS
    // http://www.filesonic.com/file/dFIxOez/Merlin.2008.S01E05.WS.PDTV.XviD-BiA.avi

    internal class UrlParser : UrlParserBase
    {
        private readonly Regex idRegex = new Regex(@"^[0-9a-zA-Z]{7}$", RegexOptions.Singleline);


        protected override IList<string> GetSupportedDomains()
        {
            return new[] { "filesonic.pl", "filesonic.com" };
        }

        protected override bool IsValidPath(Uri uri)
        {
            if (uri.Segments.Length == 3 || uri.Segments.Length == 4)
            {
                if (uri.Segments[1].Equals("file/", StringComparison.InvariantCultureIgnoreCase) == false)
                {
                    return false;
                }

                if (this.idRegex.IsMatch(uri.Segments[2].TrimEnd('/')) == false)
                {
                    return false;
                } 
                
                return true;
            }

            return false;
        }

        protected override bool IsValidQuery(Uri uri)
        {
            return true;
        }
    }
}
