﻿using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Text;
using MDownloader.Core.Server;
using MDownloader.Main.Interfaces;
using MDownloader.Search.Interfaces;
using QImpl.Filestube.Implementation.Enums;

namespace QImpl.Filestube.Implementation
{
    [Export(typeof(ISearchEngine))]
    internal class Engine : ISearchEngine
    {
        [Import]
        private IExecutor executor;


        public ISearchBag Search(IBrowser browser, ISearchQuery query, int offset = 0)
        {
            var session = browser.OpenSession();
            var request = Builder.Search.Get(query.GetSearchText(), hosting: new[] { Hosting.Rapidshare, Hosting.Megaupload, Hosting.Hotfile });
            var page = session.GetPage(request);
            var response = Parser.Search.Parse(page);

            var bag = new Bag();
            var tasks = new List<Task>();

            foreach (var result in response.Results)
            {
                var search = new Result { Id = result.Details, Name = result.Name, Provider = result.Provider, Source = result.Source };
                if (string.IsNullOrWhiteSpace(result.Details) == false)
                {
                    var task = new Task(result.Details, search);

                    tasks.Add(task);
                    bag.AddResult(search);
                }
            }

            this.executor.Execute(session, tasks.ToArray());

            return bag;
        }
    }
}
