﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EFramework.Networking.Parser;

namespace QImpl.Filestube.Implementation.Responses
{
    internal class DetailsResponseParser
    {
        public DetailsResponse Parse(HDocument page)
        {
            var result = new DetailsResponse();

            this.ProcessLinks(result, page);

            return result;
        }


        private void ProcessLinks(DetailsResponse response, HDocument document)
        {
            var links = from container in HQuery.On(document).Execute("pre#copy_paste_links")
                        from descendant in container.Descendants<HText>()
                        where String.IsNullOrWhiteSpace(descendant.Value) == false
                        from line in descendant.Value.Split(Environment.NewLine.ToCharArray(), StringSplitOptions.RemoveEmptyEntries)
                        select line;

            response.Links = links.ToArray();
        }
    }
}
