﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MDownloader.Core.Server;
using MDownloader.Main.Interfaces;
using MDownloader.Main.Interfaces.Base;

namespace QImpl.Filestube.Implementation
{
    internal class Task : TaskBase<IBrowserSession>, IExecutorTask<IBrowserSession>
    {
        private readonly string detailsLink;
        private readonly Result searchResult;


        public Task(string detailsLink, Result searchResult)
        {
            this.detailsLink = detailsLink;
            this.searchResult = searchResult;
        }


        protected override void Execute(IBrowserSession context)
        {
            var request = Builder.Details.Get(detailsLink);
            var page = context.GetPage(request);
            var response = Parser.Details.Parse(page);

            searchResult.Links = response.Links;
        }
    }
}
