﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EFramework.Core.Contracts;
using MDownloader.Main.Interfaces;

namespace QImpl.Hotfile.Implementation
{
    internal class Captcha : ICaptcha
    {
        private readonly IRecaptchaSession session;
        private readonly Action<string> onComplete;

        public Captcha(IRecaptchaSession session, Action<string> onComplete)
        {
            Ensure.IsNotNull(() => session);
            Ensure.IsNotNull(() => onComplete);

            this.session = session;
            this.onComplete = onComplete;
        }


        public byte[] GetImage()
        {
            return this.session.GetImage();
        }

        public byte[] GetAudio()
        {
            return this.session.GetAudio();
        }

        public void Refresh()
        {
            this.session.Refresh();
        }

        public void Satisfy(string text)
        {
            this.onComplete(text);
        }
    }
}
