﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EFramework.Networking;
using EFramework.Core.Contracts;

namespace QImpl.Hotfile.Implementation.Requests
{
    internal class CaptchaRequestBuilder
    {
        public NetworkRequest GetRequest(string link, string challenge, string response)
        {
            Ensure.IsNotNullNorEmpty(() => link);
            Ensure.IsNotNullNorEmpty(() => challenge);
            Ensure.IsNotNullNorEmpty(() => response);

            return new NetworkRequest(link, Guid.Empty)
            {
                PostData = new NetworkPostData
                {
                    { "action", "checkcaptcha" },
                    { "recaptcha_challenge_field", challenge },
                    { "recaptcha_response_field", response },
                }
            };
        }
    }
}
