﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EFramework.Core.Contracts;
using EFramework.Networking;
using QImpl.Hotfile.Implementation.Forms;

namespace QImpl.Hotfile.Implementation.Requests
{
    internal class DownloadRequestBuilder
    {
        public NetworkRequest Get(string link, DownloadForm form)
        {
            Ensure.IsNotNullNorEmpty(() => link);
            Ensure.IsNotNull(() => form);

            return new NetworkRequest(link, Guid.Empty)
            {
                PostData = new NetworkPostData 
                {
                    { "action", form.action },
                    { "tm", form.tm },
                    { "tmhash", form.tmhash },
                    { "wait", form.wait },
                    { "waithash", form.waithash },
                    { "upidhash", form.upidhash },
                }
            };
        }
    }
}
