﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using QImpl.Hotfile.Implementation.Responses.Interfaces;
using QImpl.Responses;

namespace QImpl.Hotfile.Implementation.Responses
{
    internal class CaptchaResponse : ResponsePartBase, IDownloadResponsePart, IFailureResponsePart
    {
        public string DownloadLink { get; set; }
        public bool HasDownloadLink
        {
            get { return String.IsNullOrWhiteSpace(this.DownloadLink) == false; }
        }

        public bool HasFailure { get; set; }


        public override bool Validate()
        {
            var filure = this.HasFailure;
            var download = this.ValidateDownload();

            return (filure == true || download == true) && filure != download;
        }

        public bool ValidateDownload()
        {
            return this.HasDownloadLink == true
                && String.IsNullOrWhiteSpace(this.DownloadLink) == false;
        }
    }
}
