﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using QImpl.Responses;

namespace QImpl.Hotfile.Implementation.Responses
{
    internal class CheckFilesResponse : ResponsePartBase
    {
        public List<Entry> Files { get; set; }

        public class Entry
        {
            public string Id { get; set; }
            public string Name { get; set; }
            public long? Size { get; set; }
            public Status Status { get; set; }

            public bool Validate()
            {
                return String.IsNullOrEmpty(this.Id) == false
                    && String.IsNullOrEmpty(this.Name) == false
                    && (this.Size.HasValue == false || this.Size.Value > 0);
            }
        }


        public override bool Validate()
        {
            return this.Files != null
                && this.Files.All(x => x.Validate());
        }


        public enum Status
        {
            NotFound = 0,
            FileOk = 1,
        }
    }
}
