﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using QImpl.Hotfile.Implementation.Forms;
using QImpl.Hotfile.Implementation.Responses.Interfaces;
using QImpl.Responses;

namespace QImpl.Hotfile.Implementation.Responses
{
    internal class DownloadResponse : ResponsePartBase, IDownloadResponsePart, ICaptchaResponsePart
    {
        public string DownloadLink { get; set; }
        public bool HasDownloadLink
        {
            get { return String.IsNullOrWhiteSpace(this.DownloadLink) == false; }
        }

        public string CaptchaLink { get; set; }
        public CaptchaForm CaptchaForm { get; set; }
        public bool HasCaptcha
        {
            get
            {
                return String.IsNullOrWhiteSpace(this.CaptchaLink) == false
                    && this.CaptchaForm != null; 
            }
        }


        public override bool Validate()
        {
            var captcha = this.ValidateCaptcha();
            var download = this.ValidateDownload();

            return (captcha == true || download == true) && captcha != download;
        }

        public bool ValidateCaptcha()
        {
            return this.HasCaptcha == true
                && String.IsNullOrWhiteSpace(this.CaptchaLink) == false
                && this.CaptchaForm != null
                && String.IsNullOrWhiteSpace(this.CaptchaForm.action) == false;
        }

        public bool ValidateDownload()
        {
            return this.HasDownloadLink == true
                && String.IsNullOrWhiteSpace(this.DownloadLink) == false;
        }
    }
}
