﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using QImpl.Hotfile.Implementation.Forms;
using QImpl.Hotfile.Implementation.Responses.Interfaces;
using QImpl.Responses;

namespace QImpl.Hotfile.Implementation.Responses
{
    internal class FileInfoResponse : ResponsePartBase, IInfoResponsePart, IWaitResponsePart, IFormResponsePart
    {
        public string Name { get; set; }
        public long Size { get; set; }
        public int Wait { get; set; }

        public DownloadForm Form { get; set; }


        public override bool Validate()
        {
            return String.IsNullOrWhiteSpace(this.Name) == false
                && this.Size > 0
                && this.Wait >= 0
                && this.Form != null
                && String.IsNullOrWhiteSpace(this.Form.action) == false
                && String.IsNullOrWhiteSpace(this.Form.tm) == false
                && String.IsNullOrWhiteSpace(this.Form.tmhash) == false
                && String.IsNullOrWhiteSpace(this.Form.wait) == false
                && String.IsNullOrWhiteSpace(this.Form.waithash) == false
                && String.IsNullOrWhiteSpace(this.Form.upidhash) == false;
        }
    }
}
