﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EFramework.Core.Contracts;
using EFramework.Networking.Parser;
using QImpl.Hotfile.Implementation.Responses.Interfaces;
using QImpl.Responses.Document;

namespace QImpl.Hotfile.Implementation.Responses.Processors
{
    /// <summary>
    /// A process to find download link at the form.
    /// </summary>
    internal class DownloadProcessor : DocumentProcessorBase<IDownloadResponsePart, HTag>
    {
        protected override Func<HDocument, HTag> GetQuery()
        {
            return document => HQuery.On(document).Execute("table#download_file a.click_download").FirstOrDefault();
        }

        protected override void Execute(IDownloadResponsePart response, HTag element)
        {
            Ensure.IsNotNull(() => response);
            Ensure.IsNotNull(() => element);

            response.DownloadLink = element.Attributes[HAttributeType.Hyperlink];          
        }
    }
}
