﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EFramework.Core.Contracts;
using EFramework.Networking.Parser;
using QImpl.Hotfile.Implementation.Responses.Interfaces;
using QImpl.Responses.Document;

namespace QImpl.Hotfile.Implementation.Responses.Processors
{
    /// <summary>
    /// A processor to find a failure message at the page.
    /// </summary>
    internal class FailureProcessor : DocumentProcessorBase<IFailureResponsePart, HTag>
    {
        protected override Func<HDocument, HTag> GetQuery()
        {
            return document => HQuery.On(document).Execute("table#download_file tr td strong span.red").FirstOrDefault();
        }

        protected override void Execute(IFailureResponsePart response, HTag element)
        {
            Ensure.IsNotNull(() => response);
            Ensure.IsNotNull(() => element);

            response.HasFailure = true;
        }
    }
}
