﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EFramework.Core.Contracts;
using EFramework.Networking.Parser;
using QImpl.Hotfile.Implementation.Forms;
using QImpl.Hotfile.Implementation.Responses.Interfaces;
using QImpl.Responses;
using QImpl.Responses.Document;

namespace QImpl.Hotfile.Implementation.Responses.Processors
{
    /// <summary>
    /// A processor to find download form at the page.
    /// </summary>
    internal class FormProcessor : DocumentProcessorBase<IFormResponsePart, HTag>
    {
        protected override Func<HDocument, HTag> GetQuery()
        {
            return document => HQuery.On(document).Execute("table#download_file form").FirstOrDefault();
        }

        protected override void Execute(IFormResponsePart response, HTag element)
        {
            Ensure.IsNotNull(() => response);
            Ensure.IsNotNull(() => element);

            response.Form = new DownloadForm
            {
                action = HQuery.On(element).Execute("input[name='action']").Select(x => x.Attributes[HAttributeType.Value]).FirstOrDefault(),
                tm = HQuery.On(element).Execute("input[name='tm']").Select(x => x.Attributes[HAttributeType.Value]).FirstOrDefault(),
                tmhash = HQuery.On(element).Execute("input[name='tmhash']").Select(x => x.Attributes[HAttributeType.Value]).FirstOrDefault(),
                wait = HQuery.On(element).Execute("input[name='wait']").Select(x => x.Attributes[HAttributeType.Value]).FirstOrDefault(),
                waithash = HQuery.On(element).Execute("input[name='waithash']").Select(x => x.Attributes[HAttributeType.Value]).FirstOrDefault(),
                upidhash = HQuery.On(element).Execute("input[name='upidhash']").Select(x => x.Attributes[HAttributeType.Value]).FirstOrDefault(),
            };
        }
    }
}
