﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EFramework.Core.Helpers;
using MDownloader.Main.Interfaces.Base;

namespace QImpl.Hotfile.Implementation
{
    // http://hotfile.com/dl/137784874/cdee641/
    // http://hotfile.com/dl/137784874/cdee641/Merlin.S04E12.hdtv.xvid-river.avi.html

    internal class UrlParser : UrlParserBase
    {
        protected override bool IsValidHost(Uri uri)
        {
            if (uri.Host.Equals("hotfile.com", StringComparison.InvariantCultureIgnoreCase))
                return true;

            if (uri.Host.EndsWith(".hotfile.com", StringComparison.InvariantCultureIgnoreCase))
                return true;

            return false;
        }

        protected override bool IsValidPath(Uri uri)
        {
            if (uri.Segments.Length == 5)
            {
                if (uri.Segments[1].Equals("dl/", StringComparison.InvariantCultureIgnoreCase) == false)
                    return false;

                if (NumberHelper.IsNumberDec(uri.Segments[2].TrimEnd('/')) == false)
                    return false;

                if (NumberHelper.IsNumberHex(uri.Segments[3].TrimEnd('/')) == false)
                    return false;

                return true;
            }

            return false;
        }

        protected override bool IsValidQuery(Uri uri)
        {
            return true;
        }


        public string GetIdentifier(string link)
        {
            return this.GetIdentifier(new Uri(link, UriKind.Absolute));
        }

        public string GetIdentifier(Uri uri)
        {
            var dec = uri.Segments[2].TrimEnd('/');
            var hex = uri.Segments[3].TrimEnd('/');

            return String.Format("{0}-{1}", dec, hex);
        }

        public string GetName(string link)
        {
            return this.GetName(new Uri(link, UriKind.Absolute));
        }

        public string GetName(Uri uri)
        {
            var name = uri.Segments[4].TrimEnd('/');

            if (name.EndsWith(".html"))
                name = name.Remove(name.Length - ".html".Length);

            return name;
        }
    }
}
