﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using MDownloader.Core.Server;
using MDownloader.Main.Interfaces;

namespace QImpl.Megaupload.Implementation
{
    internal class Resource : IProviderResource
    {
        private readonly IBrowserSession session;
        private readonly string link;

        private string target;


        public Resource(IBrowserSession session, string link)
        {
            this.session = session;
            this.link = link;
        }

        
        public string Name { get; private set; }
        public string Description { get; private set; }

        public long Size { get; private set; }
        public bool SizeExactness
        {
            get { return false; ; }
        }


        public void Initialize()
        {
            var parser = new UrlParser();
            var fileid = parser.GetId(this.link);

            var fileInfoRequest = Builder.FileInfo.Get(fileid);
            var fileInfoPage = session.GetPage(fileInfoRequest);
            var fileInfoResponse = Parser.FileInfo.Parse(fileInfoPage);

            this.Name = fileInfoResponse.Name;
            this.Size = fileInfoResponse.Size;
            this.target = fileInfoResponse.Link;
        }

        public IProviderFeedback GetFeedback()
        {
            return null;
        }

        public IProviderResourceData GetData()
        {
            return new Data(this.session, this.target);
        }
    }
}
