﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using MDownloader.Core.Server;
using MDownloader.Main.Interfaces;
using MDownloader.Main.Interfaces.Base.Feedbacks;

namespace QImpl.Rapidshare.Implementation
{
    internal class Resource : IProviderResource
    {
        private readonly IBrowserSession session;
        private readonly string link;

        private string server;
        private string downloadAuthentication;
        private int wait;


        public Resource(IBrowserSession session, string link)
        {
            this.session = session;
            this.link = link;
        }


        public string Name
        {
            get { throw new NotSupportedException(); }
        }

        public string Description
        {
            get { throw new NotSupportedException(); }
        }

        public long Size
        {
            get { throw new NotSupportedException(); }
        }

        public bool SizeExactness
        {
            get { throw new NotSupportedException(); }
        }


        public void Initialize()
        {
            var parser = new UrlParser();
            var fileid = parser.GetId(this.link);
            var filename = parser.GetName(this.link);

            var request = Builder.Download.Get(fileid, filename);
            var text = session.GetText(request);

            var response = Parser.Download.Parse(text);
            this.server = response.Server;
            this.downloadAuthentication = response.DownloadAuthentication;
        }

        public IProviderFeedback GetFeedback()
        {
            if (this.wait > 0)
            {
                return new WaitFeedback(TimeSpan.FromSeconds(this.wait), () => this.wait = 0);
            }

            return null;
        }


        public IProviderResourceData GetData()
        {
            return new Data(this.session, this.link, this.server, this.downloadAuthentication);
        }
    }
}
