﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using EFramework.Core.Contracts;

namespace QImpl.Rapidshare.Implementation.Responses
{
    internal class CheckFilesResponseParser
    {
        public CheckFilesResponse Parse(string text)
        {
            Ensure.IsNotNull(() => text);

            return new CheckFilesResponse
            {
                Files = this.ParseEntries(text.Split(new[] { '\n', '\r' }, StringSplitOptions.RemoveEmptyEntries)),
            };
        }

        private List<CheckFilesResponse.Entry> ParseEntries(IEnumerable<string> lines)
        {
            Ensure.IsNotNull(() => lines);

            var result = new List<CheckFilesResponse.Entry>();

            foreach (var line in lines)
            {
                var parts = line.Split(new[] { ',' }, StringSplitOptions.None);
                if (parts.Length != 7)
                    continue;

                result.Add(new CheckFilesResponse.Entry
                {
                    Id = parts[0],
                    Name = parts[1],
                    Size = Int64.Parse(parts[2]),
                    Server = parts[3],
                    Status = (CheckFilesResponse.Status)Int32.Parse(parts[4]),
                    Host = parts[5],
                    MD5 = parts[6],
                });
            }

            return result;
        }
    }
}
